
#pragma once

#include "../../ipc6.h"

typedef struct {
  bool CanRead;
  u32 Buttons;
  bool PenDown;
  s32 x,y;
} TDirectPenInfo;

static void DirectPenStart(void)
{
  IPC6->RequestUpdateIPC=true;
}

static const TDirectPenInfo DirectPenRead(void)
{
  TDirectPenInfo res;
  res.CanRead=false;
  
  if(IPC6->RequestUpdateIPC==true) return(res);
  
  res.CanRead=true;
  
  res.Buttons=IPC6->buttons;
  
  res.x=IPC6->touchXpx;
  res.y=IPC6->touchYpx;
  
  res.PenDown=false;
  if((res.Buttons&IPC_PEN_DOWN)!=0) res.PenDown=true;
  
  IPC6->RequestUpdateIPC=true;
  
  return(res);
}

static bool PenDownCheck(void)
{
  return(IPC6->AutoUpdatePenDownFlag);
}
